Summary: The most widely used Web server on the Internet.
Name: apache
Version: 1.3.6
%define perlsrc mod_perl-1.21
%define phpsrc  php-4.0b1
Release: 5
Group: System Environment/Daemons
Copyright: Freely distributable and usable
Url: http://www.apache.org/
Packager: Hao Li <hli@wag.caltech.edu>
Source0: ftp://ftp.apache.org/apache/dist/apache_%{version}.tar.gz
Source1: httpd.init
Source2: apache.logrotate
Source3: http://perl.apache.org/dist/%{perlsrc}.tar.gz
Source4: http://www.php.net/distributions/%{phpsrc}.tar.gz
Patch0:  apache-%{version}.patch
Patch4:  %{phpsrc}.patch
Patch5:  httpd.conf.php4.patch
BuildRoot: /var/tmp/%{name}-root
Requires: perl = 5.005_03

%description
Apache is a powerful, full-featured, efficient and freely-available
Web server. Apache is also the most popular Web server on the
Internet.

This package has following extra modules bundled in:
	%{perlsrc}
	%{phpsrc}

Server will run as httpd:httpd rather than nobody:nobody. 
Make sure user and group httpd exist before installing this package.

Documentations:
	apache:		http://www.apache.org/
	mod_perl:	http://perl.apache.org/
	mod_php:	http://www.php.net/


%prep
rm -rf $RPM_BUILD_DIR/{%{perlsrc},%{phpsrc}}
%setup -q -n apache_%{version} -b 3 -b 4
%patch0 -p1
cd ../%{phpsrc}
%patch4 -p1


%build
# Build mod_perl
cd ../%{perlsrc}
perl Makefile.PL \
	APACHE_SRC=../apache_%{version}/src \
	DO_HTTPD=1 \
	USE_APACI=1 \
	USE_DSO=1 \
	PREP_HTTPD=1 \
	EVERYTHING=1
make

# Build mod_php
cd ../apache_%{version}
./configure --prefix=/usr --disable-rule=WANTHSREGEX
cd ../%{phpsrc}
CFLAGS="$RPM_OPT_FLAGS" CPPFLAGS="$RPM_OPT_FLAGS" \
./configure \
	--with-mysql \
	--without-gd \
	--without-ttf \
	--with-system-regex \
	--disable-debug \
	--with-shared-apache=../apache_%{version} \
	--with-config-file-path=/etc/httpd \
	--enable-track-vars
make
make install

# Build Apache
cd ../%{name}_%{version}
OPTIM="$RPM_OPT_FLAGS" ./configure \
	--prefix=/usr \
	--sbindir=/usr/sbin \
	--libexecdir=/usr/lib/apache \
	--includedir=/usr/include/apache \
	--sysconfdir=/etc/httpd \
	--datadir=/home/httpd \
	--logfiledir=/var/log/httpd \
	--localstatedir=/var \
	--runtimedir=/var/run \
	--proxycachedir=/var/cache/httpd \
	--enable-module=all \
	--enable-shared=max \
	--disable-rule=WANTHSREGEX \
	--enable-module=rewrite --enable-shared=rewrite \
	--enable-module=proxy   --enable-shared=proxy \
	--activate-module=src/modules/perl/libperl.a --enable-shared=perl \
	--activate-module=src/modules/php4/libphp4.a --enable-shared=php4
make


%install
rm -rf $RPM_BUILD_ROOT
make install root=$RPM_BUILD_ROOT

# Remove bundled documentations and examples
rm -rf $RPM_BUILD_ROOT/home/httpd/{cgi-bin,htdocs}/*

# Remove outdated configuration files
rm -f $RPM_BUILD_ROOT/etc/httpd/{access,srm}.conf{,.default}

# Patch default httpd.conf
patch $RPM_BUILD_ROOT/etc/httpd/httpd.conf.default %{PATCH5}
(cd $RPM_BUILD_ROOT/etc/httpd/; cp -p httpd.conf.default httpd.conf)


# install SYSV init stuff
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
install -m755 %{SOURCE1} $RPM_BUILD_ROOT/etc/rc.d/init.d/httpd

# install log rotation stuff
mkdir -p $RPM_BUILD_ROOT/etc/logrotate.d
install -m644 %{SOURCE2} $RPM_BUILD_ROOT/etc/logrotate.d/apache


# Install mod_perl stuff
make -C ../%{perlsrc} pure_install \
	PREFIX=$RPM_BUILD_ROOT/usr \
	INSTALLMAN1DIR=$RPM_BUILD_ROOT/usr/man/man1 \
	INSTALLMAN3DIR=$RPM_BUILD_ROOT/usr/lib/perl5/5.00503/man/man3
perl -pi -e "s|^$RPM_BUILD_ROOT||" `find $RPM_BUILD_ROOT -name .packlist`


# Install mod_php stuff
install -m644 ../%{phpsrc}/php.ini-dist $RPM_BUILD_ROOT/etc/httpd/php.ini
#install -m644 ../%{phpsrc}/extra/icons/php{3,s}.gif \
#	$RPM_BUILD_ROOT/home/httpd/icons


%post
/sbin/chkconfig --add httpd

%preun
if [ $1 = 0 ]; then
   /sbin/chkconfig --del httpd
fi


%files
%defattr(-,root,root)

%dir /etc/httpd
%config /etc/httpd/*
%config /etc/logrotate.d/apache
%config /etc/rc.d/init.d/httpd

/home/httpd

/usr/bin/*
/usr/sbin/*
/usr/man/man*/*
/usr/include/apache
/usr/lib/apache

%dir %attr(-,httpd,httpd) /var/cache/httpd
%dir /var/log/httpd

# mod_perl files
/usr/lib/perl5/5.00503/man/man3/*
/usr/lib/perl5/site_perl/5.005/i386-linux/*


%clean
rm -rf $RPM_BUILD_ROOT


%changelog
